/** Checks if the string input is a number. */
function isNumber(x: string): boolean {
  if (typeof x != 'string') return false;
  return !Number.isNaN(x) && !Number.isNaN(parseFloat(x));
}
function isBoolean(s: string): boolean {
  return s == 'true' || s == 'false' || s == '0' || s == '1';
}
function toBoolean(s: string): string {
  if (s == '1' || s == 'true') return 'true';
  return 'false';
}

/** Checks if the provided value has the same as the datatype of the attribute. */
export function CheckDatatypeConstraint(type: string, str: string): string {
  let res = '';
  switch (type) {
    case 'string':
      res = str;
      break;
    case 'bool':
      isBoolean(str) ? (res = toBoolean(str)) : (res = '');
      break;
    case 'int':
    case 'float':
    case 'number':
      isNumber(str) ? (res = '' + parseFloat(str)) : (res = '');
      break;
    default:
      res = str;
      break;
  }
  return res;
}
